import socket
import shutil
import os
import re
import os
import stat
import fnmatch
import argparse
from getpass import getpass
from P4 import P4,P4Exception

def ws_cleanup_cli():
    parser = argparse.ArgumentParser()
    parser.add_argument("-r", "--regex", help="regex", action="append", required=True)
    args = parser.parse_args()
    # P4 instance creation and connection initialization
    p4 = P4()
    p4.port = input('Server Port Address: ')
    p4.user = input('Username: ')
    password = getpass('Server Connection Password: ')
    p4.password = password
    ws_cleanup_run(args, p4)

def ws_cleanup_run(args, p4):
    try:
        p4.connect()  # Connect to the Perforce server

        for ws in p4.run('clients', '-u', p4.user):
            if fnmatch.fnmatch(ws['client'], args.regex[0]):
                print('Working on WS: ' + ws['client'])
                print()
                p4.client = ws['client']

                print('Reverting changes in opened files...')
                print()
                for of in p4.run('opened', '-C', ws['client']):  # Reverting changes in opened files
                    p4.run('revert', of['depotFile'])

                print('Reverting changes in shelved files...')
                print()
                for cl in p4.run('changes', '-c', ws['client']):  # Reverting changes in opened files
                    if 'shelved' in cl:
                        p4.run('shelve', '-d', '-c', cl['change'])
                    p4.run('change', '-d', cl['change'])

                print('Deleting WS from client\'s physical location...')
                print()
                if os.path.exists(ws['Root']):  # Deleting WS from client's physical location
                    os.chmod(ws['Root'], 0o0777)
                    rmtree(ws['Root'])

                print('Deleting WS from server location...')
                print()
                p4.run('client', '-d', ws['client'])  # Deleting WS from server location
                print("====================================================")
        p4.disconnect()  # Disconnect from the server
    except P4Exception:
        raise
        for e in p4.errors:  # Display errors
            print(e)

# recursively deletes the directory by changing the permission from readOnly to 777
def rmtree(top):
    for root, dirs, files in os.walk(top, topdown=False):
        for name in files:
            filename = os.path.join(root, name)
            os.chmod(filename, stat.S_IWUSR)
            os.remove(filename)
        for name in dirs:
            os.rmdir(os.path.join(root, name))
    os.rmdir(top)
